|	TAG.S for GNU-AS
|	For comments, see TAG.A
|	ATTENTION: pc@(label) generates non-68000 code in some gas

#ifdef USE_PC_REL
#define PC_REL(a) pc@(a)
#else
#define PC_REL(a) a
#endif

.text
	moveq #-1,d0
	rts

.globl _LibName
.globl _LibId
.globl _Vectors

InitDesc:
	.short 0x4afc
	.long InitDesc
	.long EndCode	| __etext might also be used (provided by linker)
	.byte 0
	.byte 38
	.byte 9
	.byte 0
	.long _LibName
	.long _LibId
	.long Init

_LibName:
	.ascii "fifo.library\0"
_LibId:
	.ascii "fifo.library 38.2 (8.5.96)\15\12\0"

_Vectors:
	.long ALibOpen,	 ALibClose, ALibExpunge, 0
	.long AOpenFifo, ACloseFifo
	.long AReadFifo, AWriteFifo
	.long ARequestFifo, ABufSizeFifo
	.long -1

	.even
Init:
	movel a0,sp@-
	jbsr PC_REL(_LibInit)
	addqw #4,sp
	rts

ALibOpen:
	movel a6,sp@-
	movel d0,sp@-
	jbsr PC_REL(_LibOpen)
	addqw #8,sp
	rts

ALibClose:
	movel a6,sp@-
	movel d0,sp@-
	jbsr PC_REL(_LibClose)
	addqw #8,sp
	rts

ALibExpunge:
	movel a6,sp@-
	movel d0,sp@-
	jbsr PC_REL(_LibExpunge)
	addqw #8,sp
	rts

AOpenFifo:
	moveml d0/d1/a0,sp@-
	jbsr PC_REL(_OpenFifo)
	addw #12,sp
	rts

ACloseFifo:
	movel d1,sp@-
	movel d0,sp@-
	jbsr PC_REL(_CloseFifo)
	addqw #8,sp
	rts

AReadFifo:
	moveml d0/d1/a0,sp@-
	jbsr PC_REL(_ReadFifo)
	addw #12,sp
	rts

AWriteFifo:
	moveml d0/d1/a0,sp@-
	jbsr PC_REL(_WriteFifo)
	addw #12,sp
	rts

ARequestFifo:
	moveml d0/d1/a0,sp@-
	jbsr PC_REL(_RequestFifo)
	addw #12,sp
	rts

ABufSizeFifo:
	movel d0,sp@-
	jbsr PC_REL(_BufSizeFifo)
	addw #4,sp
	rts

| _BitTestSet is inlined with GCC

EndCode:
